package cn.ibizlab.businesscentral.core.base.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.businesscentral.core.base.domain.TransactionCurrency;
import cn.ibizlab.businesscentral.core.base.filter.TransactionCurrencySearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[TransactionCurrency] 服务对象接口
 */
public interface ITransactionCurrencyService extends IService<TransactionCurrency>{

    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    TransactionCurrency get(String key) ;
    boolean save(TransactionCurrency et) ;
    void saveBatch(List<TransactionCurrency> list) ;
    boolean update(TransactionCurrency et) ;
    void updateBatch(List<TransactionCurrency> list) ;
    boolean create(TransactionCurrency et) ;
    void createBatch(List<TransactionCurrency> list) ;
    TransactionCurrency getDraft(TransactionCurrency et) ;
    boolean checkKey(TransactionCurrency et) ;
    Page<TransactionCurrency> searchDefault(TransactionCurrencySearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<TransactionCurrency> getTransactioncurrencyByIds(List<String> ids) ;
    List<TransactionCurrency> getTransactioncurrencyByEntities(List<TransactionCurrency> entities) ;

}


